
#include "common.h"
#include "lex.h"
#include "block.h"
#include "expr.h"
#include "stmnt.h"

IMPORT expr_record   *  exprs ;
IMPORT ident_record  * idents ;
IMPORT block_record  * blocks ;
IMPORT stmnt_record  * stmnts ;

IMPORT  void fatal_error () ;

IMPORT void new_statement() ;
IMPORT void new_expression() ;


/*** Guarantees:
 ***    1. No global declarations.
 ***	2. No assignments to globals.
 ***	3. No assignments to non-grid locals.
 ***	4. Only ASSIGNMENT, COMPOUND & EMPTY statements.
 ***	5. All grid&local array accesses have constant index.
 ***
 ***/

EXPORT void grid_to_scanline( gridsn ) 
stmnt_number gridsn ;
{
  if ( stmnts[ gridsn ].st != stmnt_type_PASS )
    fatal_error("grid_to_scanline: But it isn't a PASS!");
  if ( stmnts[ gridsn ].v.passst.pt != pass_type_GRID )
    fatal_error("grid_to_scanline: But it isn't a GRID!");

  printf(">>>>>>\n");
  printf(">>>>>> Sorry , haven't done GRID conversion yet.\n");
  printf(">>>>>> [ Line number %0d ]\n",stmnts[ gridsn ].line_number ) ;
  printf(">>>>>>\n\n");
  gridsn = gridsn + 1 ; /** keep lint happy **/

}

